﻿<html>
您認為兩岸三通什麼時候開放比較合適?
<form runat="Server">
	<Asp:DropDownList id="D1" AutoPostBack="True" 
										OnSelectedIndexChanged="DayChg" runat="Server"/>年
	<Asp:DropDownList id="D2" AutoPostBack="True" 
										OnSelectedIndexChanged="DayChg" runat="Server"/>月
	<Asp:DropDownList id="D3" AutoPostBack="True" 
										OnSelectedIndexChanged="DayChg" runat="Server"/>日
</form>
<Asp:Label id="Label1" runat="Server"/>

<script language="VB" runat="Server">
Private Sub Page_Load(sender As Object,e As EventArgs)
	If Page.IsPostBack=True Then Return '如果不是第一次載入就不執行
	Dim shtI As Short

	For shtI=Year(Now()) To Year(Now())+5   '加入未來五年內的時間
		D1.Items.Add(shtI)
	Next

	For shtI=1 To 12 '將月份填入
		D2.Items.Add(shtI)
	Next
	D2.Items(Month(Now())-1).Selected=True '將選擇到的項目顯示為現在的月份
																				 '下列程式取得現在的月份有幾天
	For shtI=1 To Day(DateSerial(Year(Now()),Month(Now())+1,1-1)) 
		D3.Items.Add(shtI)
	Next
	D3.Items(Day(Now())-1).Selected=True '將選擇到的項目顯示為現在的日
End Sub

Private Sub DayChg(sender As Object ,e As EventArgs)
	'下列判斷如果使用者選擇日期不是今天之後, 則將日及回指定到今天

	If DateSerial(CShort(D1.SelectedItem.Text), _
								CShort(D2.SelectedItem.Text), _
								CShort(D3.SelectedItem.Text)) < Now Then

		D1.SelectedIndex=-1	'避免將DropDownList複選,
		D2.SelectedIndex=-1	'將三個DropDownList所選到
		D3.SelectedIndex=-1	'的項目清除

		D1.Items(0).Selected=True 
		D2.Items(Month(Now())-1).Selected=True
		D3.Items(Day(Now())-1).Selected=True
	End If

	Dim shtI,shtD As Short

	shtD=CShort(D3.SelectedItem.Text) '儲存使用者選取的日期
	D3.Items.Clear '移除所有的項目

	For shtI=1 To Day(DateSerial(CShort(D1.SelectedItem.Text), _
															 CShort(D2.SelectedItem.Text)+1,1-1))
		D3.Items.Add(shtI)
	Next

	'下列判斷如果使用者原先選的日期大於現在月份的日期,
	'就選擇第一天; 否則將原日期填回去

	If Day(DateSerial(CShort(D1.SelectedItem.Text), _
										CShort(D2.SelectedItem.Text)+1,1-1)) < shtD Then
		D3.Items(0).Selected=True
	Else
		D3.Items(shtD-1).Selected=True
	End If

	Label1.Text="您所選擇的日期為 " & D1.SelectedItem.Text & " 年 " & _
																		D2.SelectedItem.Text & " 月 " & _
																		D3.SelectedItem.Text & " 日"
End Sub
</script>
</html>